ModuleReference (Java SE 26 & JDK 26)
Description: declaration: module: java.base, package: java.lang.module, class: ModuleReference
Keywords: java.lang.module.ModuleReference class

# Class ModuleReference

java.lang.Object
java.lang.module.ModuleReference

public abstract class ModuleReference extends Object
A reference to a module's content.

A module reference is a concrete implementation of this class that implements the abstract methods defined by this class. It contains the module's descriptor and its location, if known. It also has the ability to create a `ModuleReader` in order to access the module's content, which may be inside the Java run-time system itself or in an artifact such as a modular JAR file.

Since:
  9
See Also:
  - `ModuleFinder`
  - `ModuleReader`

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `ModuleReference(ModuleDescriptor descriptor, URI location)`
  Constructs a new instance of this class.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `final ModuleDescriptor`
  `descriptor()`
  Returns the module descriptor.
  `final Optional<URI>`
  `location()`
  Returns the location of this module's content, if known.
  `abstract ModuleReader`
  `open()`
  Opens the module content for reading.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### ModuleReference

    protected ModuleReference(ModuleDescriptor descriptor, URI location)
    Constructs a new instance of this class.
    Parameters:
      `descriptor` - The module descriptor
      `location` - The module location or `null` if not known

- ## Method Details

  - ### descriptor

    public final ModuleDescriptor descriptor()
    Returns the module descriptor.
    Returns:
      The module descriptor

  - ### location

    public final Optional<URI> location()
    Returns the location of this module's content, if known.
    Returns:
      The location or an empty `Optional` if not known

  - ### open

    public abstract ModuleReader open() throws IOException
    Opens the module content for reading.
    Returns:
      A `ModuleReader` to read the module
    Throws:
      `IOException` - If an I/O error occurs